from sqlalchemy import Column, create_engine, func, ForeignKey
from sqlalchemy.dialects.postgresql import UUID, VARCHAR, TIMESTAMP, SMALLINT, JSONB, TEXT
from sqlalchemy.ext.declarative import declarative_base
from uuid import uuid4
from models.workers import Workers

Base = declarative_base()

class Tasks(Base):
    __tablename__ = "tasks"

    uuid = Column(UUID(as_uuid=True),primary_key=True,default=uuid4)
    worker_uuid = Column(UUID(as_uuid=True),ForeignKey(Workers.uuid), nullable=False)
    name = Column(VARCHAR(150))
    data = Column(JSONB)
    status_code = Column(VARCHAR(5))
    status = Column(VARCHAR(20))
    priority = Column(SMALLINT)
    deadline = Column(TIMESTAMP)
    requested_at = Column(TIMESTAMP)
    created_at = Column(TIMESTAMP,server_default=func.current_timestamp())
    updated_at = Column(TIMESTAMP,onupdate=func.current_timestamp())

if __name__ == "__main__":
    engine = create_engine("postgresql://dev:rUtbkp6uE752Amsw@35.223.124.237:5432/task_manager")
    Base.metadata.create_all(bind=engine)